var RandomUtil = {};
RandomUtil.pick = function(pool, exceptions)
{
	if (exceptions != null)
	{
		var pool2 = [];
		var n = pool.length;
		for (var i = 0; i < n; i++)
		{
			var item = pool[i];
			if (exceptions.indexOf(item) == -1) pool2.push(item);
		}
		pool = pool2;
	}
	return pool[Math.floor(Math.random() * pool.length)];
}
RandomUtil.between = function(min, max, integer, extremeFactor)
{
	var p = Math.random();
	if (extremeFactor)
	{
		var f = Math.pow((p < .5) ? p * 2 : (1 - p) * 2, extremeFactor);
		p = (p < .5) ? f / 2 : 1 - (f / 2);
	}
	var n = min + p * (max-min);
	if (integer) return Math.floor(n);
	else return n;
}

RandomUtil.rnd = function(params)
{
	if (!params) return Math.random();
	if (params.length)
	{
		if (params.length==1) return Math.random()*params[0];
		if (params.length==2) return RandomUtil.between.apply(null, params);
		else return RandomUtil.pick.apply(null, params);
	}
	if (!isNaN(params)) return Math.random()*params;
	return Math.random();
}

var MathUtil = {};
MathUtil.lerp = function(v0,v1,t, clamp)
{
	if (clamp) t = Math.max(0,Math.min(1,t));
	var v = v0 + (v1-v0)*t;
	return v;
}